## relion-cuda 3.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8 FATAL_ERROR)

#if(POLICY CMP0048)
#  cmake_policy(SET CMP0048 NEW)
#endif()
project(Relion)

# Use new policy for OS X @rpath
if(POLICY CMP0042)
    cmake_policy(SET CMP0042 NEW)
endif()

# Add the path to the additional Find<module>.cmake files 
# which are included with the distributed RLEION-code
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

add_definitions(-DINSTALL_LIBRARY_DIR=${CMAKE_INSTALL_PREFIX}/lib/)
add_definitions(-DSOURCE_DIR=${CMAKE_SOURCE_DIR}/src/)

if(MDT_TYPE_CHECK)
    message(" DEVELOPER MODE: MetaDataTable type check is enabled.")
    add_definitions(-DMETADATA_TABLE_TYPE_CHECK)
endif()

# message(STATUS "INSTALL_LIBRARY_DIR set to ${CMAKE_INSTALL_PREFIX}/lib/")
# message(STATUS "SOURCE_DIR set to ${CMAKE_SOURCE_DIR}/src/")

# ------------------------------------------------------------------RPATH SETTINGS--
if(NOT APPLE)
    # use, i.e. don't skip the full RPATH for the build tree
    SET(CMAKE_SKIP_BUILD_RPATH  FALSE)

    # when building, don't use the install RPATH already
    # (but later on when installing)
    SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)

    SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")

    # add the automatically determined parts of the RPATH
    # which point to directories outside the build tree to the install RPATH
    SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)


    # the RPATH to be used when installing, but only if it's not a system directory
    LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
    IF("${isSystemDir}" STREQUAL "-1")
        SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
    ENDIF("${isSystemDir}" STREQUAL "-1")
endif(NOT APPLE)

# ---------------------------------------------------------SET SPECIFIC BUILD TYPE--
if(NOT ${CMAKE_BUILD_TYPE} STREQUAL "")
	string( TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_LOWER )
	
	if( ( NOT ${CMAKE_BUILD_TYPE_LOWER} STREQUAL "none" ) AND
	    ( NOT ${CMAKE_BUILD_TYPE_LOWER} STREQUAL "release" ) AND 
	    ( NOT ${CMAKE_BUILD_TYPE_LOWER} STREQUAL "debug" ) AND
	    ( NOT ${CMAKE_BUILD_TYPE_LOWER} STREQUAL "relwithdebinfo" ) AND 
	    ( NOT ${CMAKE_BUILD_TYPE_LOWER} STREQUAL "profiling" )  AND 
	    ( NOT ${CMAKE_BUILD_TYPE_LOWER} STREQUAL "benchmarking" ) )
	     message( FATAL_ERROR "CMAKE_BUILD_TYPE : '${CMAKE_BUILD_TYPE}' is not a valid build type. "
		"Valid options are: 'None', 'Release', 'Debug', 'RelWithDebInfo', and 'Profiling'." )
	endif()
	
	message(STATUS "BUILD TYPE set to '${CMAKE_BUILD_TYPE}'")
	SET(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "Choose the type of
build, options are: 'None', 'Release', 'Debug', 'RelWithDebInfo', and 'Profiling'.")
else()
	SET(CMAKE_BUILD_TYPE "Release")
	message(STATUS "BUILD TYPE set to the default type:  '${CMAKE_BUILD_TYPE}'")
	string( TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_LOWER )
endif()

# ------------------OPTIONS WHICH ARE NEEDED TO SET BUILD-TYPES (COMPILATION FLAGS)--
# ------------------------------------------------------------------------CUDA-ARCH--
if(NOT DEFINED CUDA_ARCH)
    message(STATUS "Setting fallback CUDA_ARCH=35")
    set(CUDARCH "-arch=sm_35")
else(NOT DEFINED CUDA_ARCH)
    message(STATUS "Using provided CUDA_ARCH=${CUDA_ARCH}")
    set(CUDARCH "-arch=sm_${CUDA_ARCH}")
endif(NOT DEFINED CUDA_ARCH)
    
# -------------------------------------------------------------------FURTHER OPTIONS--


# CUDA on by default, so check for CPU-accelration request and possible conflicting dual-request
option(ALTCPU "Enable Accelerated CPU version" OFF)
if(ALTCPU)
	option(CUDA "Enable CUDA GPU acceleration" OFF)
	if(ALTCPU AND CUDA)
   		message(FATAL_ERROR "You cannot build with both CUDA=ON and ALTCPU=ON.  Please choose one and rerun CMAKE")
	endif()
else()
	option(CUDA "Enable CUDA GPU acceleration" ON)
endif()

option(DoublePrec_CPU "DoublePrec_CPU" ON)
option(DoublePrec_ACC "Accelerated Code use double-precision" OFF)
option(MKLFFT "Use MKL rather than FFTW for FFT" OFF)
option(CudaTexture "CudaTexture" ON)
option(ALLOW_CTF_IN_SAGD "Allow CTF-modulation in SAGD, as specified in Claim 1 of patent US10,282,513B2" ON)

if(ALLOW_CTF_IN_SAGD)
    message(STATUS "ALLOW_CTF_IN_SAGD enabled - This build of RELION allows modulation of particle images by a contrast transfer function inside stochastic average gradient descent, as specified in Claim 1 of patent US10,282,513B2")
else()
    message(STATUS "ALLOW_CTF_IN_SAGD disabled - This build of RELION does not allow modulation of particle images by a contrast transfer function inside stochastic average gradient descent, as specified in Claim 1 of patent US10,282,513B2")
endif()

if(ALTCPU)
    message(STATUS "ALTCPU enabled - Building CPU-accelerated version of RELION")
endif()

if(CUDA)
    message(STATUS "CUDA enabled - Building CUDA-accelerated version of RELION")
endif()

if(CUDA OR ALTCPU)
    add_definitions(-DACC_CUDA=2 -DACC_CPU=1)
endif()

# -----------------------------------------------DOUBLE PRECISION (CUDA-CODE) OR NOT--
if(DoublePrec_CPU)
    message(STATUS "Setting cpu precision to double")    
else(DoublePrec_CPU)
    message(STATUS "Setting cpu precision to single")
    add_definitions(-DRELION_SINGLE_PRECISION)
endif(DoublePrec_CPU)

if(DoublePrec_ACC)
    message(STATUS "Setting accelerated code precision to double")
    add_definitions(-DACC_DOUBLE_PRECISION)
	set(CudaTexture FALSE)
else(DoublePrec_ACC)
    message(STATUS "Setting accelerated code precision to single")
endif(DoublePrec_ACC)

# ----------------------------------------------------------INCLUDE ALL BUILD TYPES--
 #This *has* to be AFTER project()
include(${CMAKE_SOURCE_DIR}/cmake/BuildTypes.cmake)

if(CUDA)
    # -----------------------------------------------------------------------------CUDA--
    # DOC: http://www.cmake.org/cmake/help/v3.0/module/FindCUDA.html
    FIND_PACKAGE(CUDA)
endif()

if(CUDA_FOUND)
    message(STATUS "Using cuda wrapper to compile....")
    if( (NOT ${CUDA_VERSION} VERSION_LESS "7.5") AND (NOT DoublePrec_ACC) )
        message(STATUS "Cuda version is >= 7.5 and single-precision build, enable double usage warning.")
		set(WARN_DBL "--ptxas-options=-warn-double-usage") # cuda>=7.5
	elseif( ${CUDA_VERSION} VERSION_LESS "7.0")
		message(WARNING "Cuda version is less than 7.0, so relion will be compiled without GPU support.")
		set(CUDA OFF)
    endif()
    
    if(CUDA)
        add_definitions(-DCUDA)
    endif()
else(CUDA_FOUND)
    message(STATUS "Using non-cuda compilation....")
endif(CUDA_FOUND)

# ------------------------------------------------------------------ALLOCATOR CHOICE--
option(CachedAlloc "CachedAlloc" ON)
if(NOT CachedAlloc)
    add_definitions(-DCUDA_NO_CUSTOM_ALLOCATION)
	message(STATUS "Cached allocation is disabled.")
endif(NOT CachedAlloc)
option(CustomAllocMemGuards "CustomAllocMemGuards" OFF)
if(CustomAllocMemGuards)
    add_definitions(-DCUSTOM_ALLOCATOR_MEMGUARD)
    message(STATUS "Abort on out of bound write.")
endif(CustomAllocMemGuards)
# -------------------------------------------------------------FORCE USE OF STL-LIBS--
option(CudaForceSTL "CudaForceSTL" OFF)
if(CudaForceSTL)
    add_definitions(-DCUDA_FORCESTL)
    message(STATUS "Building cuda files wusing stl-libs for sort, min and max.")
endif(CudaForceSTL)

# ------------------------------------------------------------------------GUI OR NOT--
# Skip FLTK/X11-dependent binaries or not
option(GUI "GUI" ON)
if(NOT GUI)
    message(STATUS "Omitting GUI targets as per your request")
endif()

# ---------------------------------------------------------------------------TBB --

option(FORCE_OWN_TBB "FORCE_OWN_TBB" OFF)

if (ALTCPU)
	
	if (FORCE_OWN_TBB)
		message(STATUS "Will ignore any potentially installed system TBB lib, as per your request.")
		include(${CMAKE_SOURCE_DIR}/cmake/BuildTBB.cmake)
		set(INSTALL_OWN_TBB 1)
	else(FORCE_OWN_TBB)
		find_package(TBB)
		if(TBB_FOUND)
			include_directories("${TBB_INCLUDE_DIRS}")
			message(STATUS "TBB_FOUND :        ${TBB_FOUND}")
			message(STATUS "TBB_INCLUDE_DIRS : ${TBB_INCLUDE_DIRS}")
			message(STATUS "TBB_VERSION :      ${TBB_VERSION}")
			message(STATUS "TBB_LIBRARIES :    ${TBB_LIBRARIES}")
		else(TBB_FOUND)
			include(${CMAKE_SOURCE_DIR}/cmake/BuildTBB.cmake)
			set(INSTALL_OWN_TBB 1)
		endif(TBB_FOUND)
	endif(FORCE_OWN_TBB)
endif(ALTCPU)

# -------------------------------------------------------------------------------MPI--
find_package(MPI REQUIRED)

if ("${MPI_CXX_INCLUDE_DIRS}" STREQUAL "")
	include_directories("${MPI_CXX_INCLUDE_PATH}")
else()
	include_directories("${MPI_CXX_INCLUDE_DIRS}")
endif()

message(STATUS "MPI_INCLUDE_PATH : ${MPI_INCLUDE_PATH}")
message(STATUS "MPI_LIBRARIES : ${MPI_LIBRARIES}")
message(STATUS "MPI_CXX_INCLUDE_PATH : ${MPI_CXX_INCLUDE_PATH}")
message(STATUS "MPI_CXX_LIBRARIES : ${MPI_CXX_LIBRARIES}")

message(STATUS "CMAKE_C_COMPILER : ${CMAKE_C_COMPILER}")
message(STATUS "CMAKE_CXX_COMPILER : ${CMAKE_CXX_COMPILER}")
message(STATUS "MPI_C_COMPILER : ${MPI_C_COMPILER}")
message(STATUS "MPI_CXX_COMPILER : ${MPI_CXX_COMPILER}")

set(SAVE_CMAKE_C_COMPILER ${CMAKE_C_COMPILER})
set(SAVE_CMAKE_CXX_COMPILER ${CMAKE_CXX_COMPILER})
SET(CMAKE_C_COMPILER ${MPI_C_COMPILER})
SET(CMAKE_CXX_COMPILER ${MPI_CXX_COMPILER})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

# ----------------------------------------------------------Intel Compiler support --
# ----------------------------------  and build flags including MKL and TBB ---------

message(STATUS "CMAKE_CXX_COMPILER_ID : ${CMAKE_CXX_COMPILER_ID}")
if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
    if(MKLFFT)
        SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fopenmp -mkl -limf ")
    	add_definitions(-DMKLFFT)
    endif(MKLFFT)
    if(ALTCPU)
        add_definitions(-DFAST_CENTERFFT)
    endif()
    SET(CudaTexture OFF)
    SET(CMAKE_C_COMPILER ${SAVE_CMAKE_C_COMPILER})
    SET(CMAKE_CXX_COMPILER ${SAVE_CMAKE_CXX_COMPILER})
    SET(MPI_C_COMPILER ${SAVE_CMAKE_C_COMPILER})
    SET(MPI_CXX_COMPILER ${SAVE_CMAKE_CXX_COMPILER})
else()
    if(MKLFFT)
        # For the time being, let's use the sequential version (as with FFTW)
        SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -lmkl_intel_ilp64 -lmkl_core -lmkl_sequential ")
        add_definitions(-DMKLFFT)
    endif(MKLFFT)
endif()

message(STATUS "CMAKE_C_COMPILER : ${CMAKE_C_COMPILER}")
message(STATUS "CMAKE_CXX_COMPILER : ${CMAKE_CXX_COMPILER}")
message(STATUS "MPI_C_COMPILER : ${MPI_C_COMPILER}")
message(STATUS "MPI_CXX_COMPILER : ${MPI_CXX_COMPILER}")

if(ALTCPU)
    add_definitions(-DALTCPU)
endif()

if(ALLOW_CTF_IN_SAGD)
    add_definitions(-DALLOW_CTF_IN_SGD)
endif()

# ---------------------------------------------------------------USE TEXTURES OR NOT--
if(NOT CudaTexture OR ALTCPU)
    add_definitions(-DPROJECTOR_NO_TEXTURES)
    message(STATUS "Texture interpolation is omitted.")
endif(NOT CudaTexture OR ALTCPU)

# --------------------------------------------------------------------------X11/FLTK--
option(FORCE_OWN_FLTK "FORCE_OWN_FLTK" OFF)
FIND_PACKAGE(X11)
if(GUI)
    if(X11_FOUND)
        set(FLTK_SKIP_OPENGL TRUE) #OpenGL is not required for relion
        if(NOT FORCE_OWN_FLTK)
            FIND_PACKAGE(FLTK)
		    if(FLTK_FOUND)
				message(STATUS "X11 and FLTK were found")
				message(STATUS "FLTK_LIBRARIES: ${FLTK_LIBRARIES}")
		    else()
				message(STATUS "No FLTK installation was found")
		    endif() 
        endif(NOT FORCE_OWN_FLTK)
        
	if(NOT FLTK_FOUND)
		include(${CMAKE_SOURCE_DIR}/cmake/BuildFLTK.cmake)
		set(INSTALL_OWN_FLTK 1)
	endif(NOT FLTK_FOUND)

    else(X11_FOUND)
        message( STATUS "\n-- ------------------ YOU HAVE NO X11-LIBS ------------------")
        message( STATUS "CCmake found no X11-libs on your system, which are required for the GUI.")

=== src/apps/CMakeLists.txt ===
include_directories("${CMAKE_SOURCE_DIR}")

message("Running apps/CMakeLists.txt...")

if(NOT MKLFFT)
	include_directories("${FFTW_INCLUDES}")
endif(NOT MKLFFT)
#include_directories(${CMAKE_BINARY_DIR}/include)

find_path (X11_INCLUDES Xdbe.h)

message(STATUS "CMAKE_BINARY_DIR:" ${CMAKE_BINARY_DIR})

file(GLOB REL_GUI_SRC "${CMAKE_SOURCE_DIR}/src/manualpicker.cpp" "${CMAKE_SOURCE_DIR}/src/gui_*.cpp" "${CMAKE_SOURCE_DIR}/src/displayer.cpp")

# AUTOMATIC VERSIONING
# Reference: https://stackoverflow.com/questions/1435953/how-can-i-pass-git-sha1-to-compiler-as-definition-using-cmake

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/")
include(GetGitRevisionDescription)
get_git_head_revision(GIT_REFSPEC GIT_SHA1_FULL)
string(SUBSTRING ${GIT_SHA1_FULL} 0 6 GIT_SHA1)
message(STATUS "Git commit ID: ${GIT_SHA1_FULL}")
configure_file("${CMAKE_SOURCE_DIR}/src/macros.cpp.in" "${CMAKE_BINARY_DIR}/macros.cpp" @ONLY)

if (ALTCPU)
	file(GLOB REL_SRC "${CMAKE_SOURCE_DIR}/src/*.cpp" "${CMAKE_BINARY_DIR}/macros.cpp" "${CMAKE_SOURCE_DIR}/src/*.c" "${CMAKE_SOURCE_DIR}/src/acc/cpu/*.cpp" "${CMAKE_SOURCE_DIR}/src/acc/cpu/cpu_kernels/*.cpp" )
	file(GLOB REL_SRC_H "${CMAKE_SOURCE_DIR}/src/*.h" "${CMAKE_SOURCE_DIR}/src/acc/*.h" "${CMAKE_SOURCE_DIR}/src/acc/cpu/*.h" "${CMAKE_SOURCE_DIR}/src/acc/cpu/cpu_kernels/*.h" )
else()
	file(GLOB REL_SRC "${CMAKE_SOURCE_DIR}/src/*.cpp" "${CMAKE_BINARY_DIR}/macros.cpp" "${CMAKE_SOURCE_DIR}/src/*.c" "${CMAKE_SOURCE_DIR}/src/acc/*.cpp" )
	file(GLOB REL_SRC_H "${CMAKE_SOURCE_DIR}/src/*.h" "${CMAKE_SOURCE_DIR}/src/acc/*.h" ) 
endif(ALTCPU)

# Remove GUI files from relion_lib
foreach(GUI_SRC_FILE ${REL_GUI_SRC})
	list(REMOVE_ITEM REL_SRC "${GUI_SRC_FILE}")
endforeach()

file(GLOB REL_JAZ_SRC "${CMAKE_SOURCE_DIR}/src/jaz/*.cpp")
file(GLOB REL_JAZ_H "${CMAKE_SOURCE_DIR}/src/jaz/*.h")
file(GLOB REL_JAZ_OPT_SRC "${CMAKE_SOURCE_DIR}/src/jaz/optimization/*.cpp")
file(GLOB REL_JAZ_OPT_H "${CMAKE_SOURCE_DIR}/src/jaz/optimization/*.h")
file(GLOB REL_JAZ_CTF_SRC "${CMAKE_SOURCE_DIR}/src/jaz/ctf/*.cpp")
file(GLOB REL_JAZ_CTF_H "${CMAKE_SOURCE_DIR}/src/jaz/ctf/*.h")
file(GLOB REL_JAZ_MOTION_SRC "${CMAKE_SOURCE_DIR}/src/jaz/motion/*.cpp")
file(GLOB REL_JAZ_MOTION_H "${CMAKE_SOURCE_DIR}/src/jaz/motion/*.h")
file(GLOB REL_JAZ_MATH_SRC "${CMAKE_SOURCE_DIR}/src/jaz/math/*.cpp")
file(GLOB REL_JAZ_MATH_H "${CMAKE_SOURCE_DIR}/src/jaz/math/*.h")
file(GLOB REL_JAZ_IMG_PROC_SRC "${CMAKE_SOURCE_DIR}/src/jaz/img_proc/*.cpp")
file(GLOB REL_JAZ_IMG_PROC_H "${CMAKE_SOURCE_DIR}/src/jaz/img_proc/*.h")
file(GLOB REL_JAZ_TOMO_SRC "${CMAKE_SOURCE_DIR}/src/jaz/tomo/*.cpp")
file(GLOB REL_JAZ_TOMO_H "${CMAKE_SOURCE_DIR}/src/jaz/tomo/*.h")
file(GLOB REL_JAZ_IO_SRC "${CMAKE_SOURCE_DIR}/src/jaz/io/*.cpp")
file(GLOB REL_JAZ_IO_H "${CMAKE_SOURCE_DIR}/src/jaz/io/*.h")
file(GLOB REL_D3x3_SRC "${CMAKE_SOURCE_DIR}/src/jaz/d3x3/*.c")
file(GLOB REL_D3x3_H "${CMAKE_SOURCE_DIR}/src/jaz/d3x3/*.h")
file(GLOB REL_LBFGS_SRC "${CMAKE_SOURCE_DIR}/src/jaz/lbfgs/*.c")
file(GLOB REL_LBFGS_H "${CMAKE_SOURCE_DIR}/src/jaz/lbfgs/*.h")

file(GLOB REL_HP "${CMAKE_SOURCE_DIR}/src/Healpix_2.15a/*.cc")
file(GLOB RELION_TARGETS "${CMAKE_SOURCE_DIR}/src/apps/*.cpp")

set(GUI_TARGETS display maingui manualpick pipeliner)

#--Remove apps using X11 if no GUI--
if(NOT GUI)
	foreach(TARGET ${GUI_TARGETS})
		list(REMOVE_ITEM RELION_TARGETS "${CMAKE_SOURCE_DIR}/src/apps/${TARGET}.cpp")
	endforeach()
endif(NOT GUI)

#--Remove apps for testing--
#SET(RELION_TEST TRUE)
set(TEST_TARGETS double_reconstruct_openmp cs_fit ctf_nyquist_test free_aberration_plot split_stack defocus_stats double_bfac_fit interpolation_test motion_diff paper_data_synth Zernike_test vis_delocalisation vis_Ewald_weight)
if(NOT RELION_TEST)
	foreach(TARGET ${TEST_TARGETS})
		list(REMOVE_ITEM RELION_TARGETS "${CMAKE_SOURCE_DIR}/src/apps/${TARGET}.cpp")
	endforeach()
endif(NOT RELION_TEST)

# relion_lib is STATIC or SHARED type based on BUILD_SHARED_LIBS=ON/OFF
# relion_lib only contains non-X11 parts
# relion_gui_lib is where the X11 code is placed
if(BUILD_SHARED_LIBS)
	add_library(relion_lib SHARED
	            ${REL_SRC} ${REL_SRC_H} ${REL_HP}
	            ${REL_JAZ_SRC} ${REL_JAZ_H}
	            ${REL_JAZ_OPT_SRC} ${REL_JAZ_OPT_H}
	            ${REL_JAZ_CTF_SRC} ${REL_JAZ_CTF_H}
	            ${REL_JAZ_MOTION_SRC} ${REL_JAZ_MOTION_H}
	            ${REL_JAZ_MATH_SRC} ${REL_JAZ_MATH_H}
	            ${REL_JAZ_IMG_PROC_SRC} ${REL_JAZ_IMG_PROC_H}
	            ${REL_JAZ_TOMO_SRC} ${REL_JAZ_TOMO_H}
	            ${REL_JAZ_IO_SRC} ${REL_JAZ_IO_H}
	            ${REL_D3x3_SRC} ${REL_D3x3_H}
	            ${REL_LBFGS_SRC} ${REL_LBFGS_H})

	install(TARGETS relion_lib LIBRARY DESTINATION lib)
	if(GUI)
		add_library(relion_gui_lib SHARED ${REL_GUI_SRC} ${REL_SRC_H} ${REL_HP})
		install(TARGETS relion_gui_lib LIBRARY DESTINATION lib)
	endif(GUI)
else()
	add_library(relion_lib STATIC
		${REL_SRC} ${REL_SRC_H} ${REL_HP}
		${REL_JAZ_SRC} ${REL_JAZ_H}
		${REL_JAZ_OPT_SRC} ${REL_JAZ_OPT_H}
		${REL_JAZ_CTF_SRC} ${REL_JAZ_CTF_H}
		${REL_JAZ_MOTION_SRC} ${REL_JAZ_MOTION_H}
		${REL_JAZ_MATH_SRC} ${REL_JAZ_MATH_H}
		${REL_JAZ_IMG_PROC_SRC} ${REL_JAZ_IMG_PROC_H}
		${REL_JAZ_TOMO_SRC} ${REL_JAZ_TOMO_H}
		${REL_JAZ_IO_SRC} ${REL_JAZ_IO_H}
		${REL_D3x3_SRC} ${REL_D3x3_H}
		${REL_LBFGS_SRC} ${REL_LBFGS_H})

	if(GUI)
		add_library(relion_gui_lib STATIC ${REL_GUI_SRC} ${REL_SRC_H} ${REL_HP})
	endif(GUI)
endif()

if(NOT MKLFFT)
	target_link_libraries(relion_lib ${FFTW_LIBRARIES})
	if(BUILD_OWN_FFTW)
		add_dependencies(relion_lib own_fftw_lib)
	endif()
	if(BUILD_OWN_FFTWF)
		add_dependencies(relion_lib own_fftwf_lib)
	endif()
endif(NOT MKLFFT)

if(GUI)
	include_directories("${FLTK_INCLUDE_DIR}")
	target_link_libraries(relion_gui_lib relion_lib ${FLTK_LIBRARIES})
	if(BUILD_OWN_FLTK)
		add_dependencies(relion_gui_lib OWN_FLTK)
	endif()
endif(GUI)

if (CUDA_FOUND)
	file(GLOB REL_CUDA_SRC "${CMAKE_SOURCE_DIR}/src/acc/cuda/*.cu" "${CMAKE_SOURCE_DIR}/src/acc/cuda/cuda_kernels/*.cu" )
	cuda_add_library(relion_gpu_util ${REL_CUDA_SRC})

	if (${CMAKE_BUILD_TYPE_LOWER} STREQUAL "profiling")
		find_library(NV_TOOLS_LIBRARIES   NAMES nvToolsExt  PATHS ${CUDA_TOOLKIT_ROOT_DIR}/lib ${CUDA_TOOLKIT_ROOT_DIR}/lib64)
		list(APPEND EXTRA_LIBS "${NV_TOOLS_LIBRARIES}")
		target_link_libraries(relion_gpu_util ${NV_TOOLS_LIBRARIES})
		message(STATUS "Adding extra library for NVIDIA profiling: ${NV_TOOLS_LIBRARIES}")
	endif()

	# Presently we have a number of (bad) circular dependencies between the gpu util
	# and relion libraries, which cause errors at least on OS X with clang. Tell the
	# compiler to ignore them.
	if(APPLE)
		set(new_link_flags "-undefined suppress -flat_namespace")
		get_target_property(existing_link_flags relion_gpu_util LINK_FLAGS)
		if(existing_link_flags)
			set(new_link_flags "${existing_link_flags} ${new_link_flags}")
		endif()
		set_target_properties(relion_gpu_util PROPERTIES LINK_FLAGS "${new_link_flags}")
	endif()

	list(APPEND EXTRA_LIBS "${CUDA_CUFFT_LIBRARIES}")
	if(BUILD_SHARED_LIBS)
		install (TARGETS relion_gpu_util LIBRARY DESTINATION lib)
	else()
		target_link_libraries(relion_gpu_util relion_lib)
		target_link_libraries(relion_gpu_util ${CUDA_CUFFT_LIBRARIES})
	endif()

	target_link_libraries(relion_lib relion_gpu_util ${CUDA_CUFFT_LIBRARIES})
	target_link_libraries(relion_lib relion_gpu_util ${CUDA_CUFFT_LIBRARIES} ${CUDA_curand_LIBRARY})
endif(CUDA_FOUND)

if(TIFF_FOUND)
	#message("TIFF FOUND")
	include_directories(${TIFF_INCLUDE_DIRS})
	target_link_libraries(relion_lib ${TIFF_LIBRARIES})
else()
	#message("TIFF NOT FOUND")
endif()

if(PNG_FOUND)
	#message("PNG FOUND")
	include_directories(${PNG_INCLUDE_DIRS})
	target_link_libraries(relion_lib ${PNG_LIBRARY})
else()
	#message("PNG NOT FOUND")
endif()

if(BUILD_OWN_TBB)
	add_dependencies(relion_lib OWN_TBB)
endif()

foreach (_target ${RELION_TARGETS})
	GET_FILENAME_COMPONENT(_target "relion_${_target}" NAME_WE)  #specify target name WE=WithoutExtension
	
	add_executable(${_target} ${_target}.cpp )
	set(LIB relion_lib)
	
 	add_dependencies(${_target} relion_lib)
	
	set_target_properties(${_target} PROPERTIES PREFIX "relion_")

	if(NOT MKLFFT)
		target_link_libraries(${_target} ${LIB} ${EXTRA_LIBS} ${MPI_LIBRARIES} ${CMAKE_DL_LIBS})
	else()	
		target_link_libraries(${_target} ${LIB} ${FFTW_LIBRARIES} ${EXTRA_LIBS} ${MPI_LIBRARIES} ${CMAKE_DL_LIBS})
	endif(NOT MKLFFT)

	if(CUDA_FOUND)
		target_link_libraries(${_target} relion_gpu_util)
	endif(CUDA_FOUND)
	
	if (ALTCPU)
		target_link_libraries(${_target} ${TBB_LIBRARIES})
	endif(ALTCPU)

	set_target_properties(${_target} PROPERTIES
	                      XX_STANDARD 11
	                      XX_STANDARD_REQUIRED ON
	                      XX_EXTENSIONS OFF
	)
	
	list(FIND GUI_TARGETS ${_target} IS_GUI_TARGET)
	if(NOT ${IS_GUI_TARGET} LESS 0)
		add_dependencies(${_target} relion_gui_lib)
		target_link_libraries(${_target} relion_gui_lib ${FLTK_LIBRARIES} ${X11})
	endif()

	if(TIFF_FOUND)
		target_link_libraries(${_target} ${TIFF_LIBRARIES})
	endif()
    
	#message(STATUS "added ${_target}...")
	
	install (TARGETS ${_target} RUNTIME DESTINATION bin)
endforeach()

if(GUI)
	ADD_CUSTOM_COMMAND(TARGET maingui
	                   POST_BUILD
                           COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_BINARY_DIR}/bin/relion_maingui ${PROJECT_BINARY_DIR}/bin/relion
                           COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_BINARY_DIR}/bin/relion_qsub.csh ${PROJECT_BINARY_DIR}/bin/qsub.csh
	)
endif(GUI)

FIND_PACKAGE( OpenMP REQUIRED)
if(OPENMP_FOUND)
	#message("OPENMP FOUND")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
	set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OpenMP_EXE_LINKER_FLAGS}")
	target_link_libraries(relion_lib ${OpenMP_omp_LIBRARY})
endif()

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")

# Set this flag to activate bounds checking in stl-vectors (incl. strings)
# It is useful to do this periodically, as it catches 
# difficult-to-see and rare-to-manifest bugs
# set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_GLIBCXX_DEBUG")

=== src/jaz/gravis/private/CMakeLists.txt ===
set( install_files
    OBJReader.hxx
    OBJWriter.hxx
    tDeterminants.h
    tImageConverter.hxx
    tImageConvolution.hxx
    tImageIO.hxx
    tImageIO_JPG.hxx
    tImageIO_PNG.hxx
    tImageIO_PNM.hxx
    tRefCPtr.h
    )
INSTALL(FILES ${install_files} 
        DESTINATION
        ${CMAKE_INSTALL_PREFIX}/include/${LIBTITLE}-${LIBVERSION}/${LIBTITLE}/private)

=== src/jaz/gravis/tImage/CMakeLists.txt ===
set( install_files
    access.hxx
    distance_transform.h
    draw.h
    interpolation.hxx
    normalization.h
    operators.h
    traits.h
    )
INSTALL(FILES ${install_files} 
        DESTINATION
        ${CMAKE_INSTALL_PREFIX}/include/${LIBTITLE}-${LIBVERSION}/${LIBTITLE}/tImage)

=== src/jaz/gravis/io/mesh/CMakeLists.txt ===
set( install_files
    absolute_paths.h
    msh.h
    obj.h
    OBJReader.h
    OBJWriter.h
    )
INSTALL(FILES ${install_files} 
        DESTINATION
        ${CMAKE_INSTALL_PREFIX}/include/${LIBTITLE}-${LIBVERSION}/${LIBTITLE}/io/mesh)

=== debian/changelog ===
relion-cuda (3.1.0-2) unstable; urgency=medium

  * Team upload.
  * Drop myself from Uploaders
  * Add missing Build-Depends: fluid
    Closes: #973776
  * Do not set explicitly old compiler version

 -- Andreas Tille <tille@debian.org>  Sat, 05 Dec 2020 11:56:22 +0100

relion-cuda (3.1.0-1) unstable; urgency=medium

  * Initial upload of this cuda enabled relion version

 -- Roland Fehrenbacher <rfehren@debian.org>  Thu, 01 Oct 2020 10:37:37 +0200

=== debian/control ===
Source: relion-cuda
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Roland Fehrenbacher <rfehren@debian.org>
Section: contrib/science
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               libfftw3-dev,
               libfltk1.3-dev,
               libopenmpi-dev,
               libtiff-dev,
               nvidia-cuda-toolkit,
               fluid
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/med-team/relion
Vcs-Git: https://salsa.debian.org/med-team/relion.git
Homepage: https://www2.mrc-lmb.cam.ac.uk/relion/index.php/Main_Page

Package: relion-cuda
Section: contrib/science
Architecture: amd64 i386
Depends: openmpi-gcc | openmpi-bin,
         ${misc:Depends},
         ${shlibs:Depends},
Breaks: relion-bin,
        relion-bin+gui,
        relion-bin+mpi,
        relion-bin+mpi+gui,
Replaces: relion-bin,
          relion-bin+gui,
          relion-bin+mpi,
          relion-bin+mpi+gui,
Conflicts: relion,
Description: parallel toolkit for 3D reconstructions in cryo-electron microscopy
 RELION (for REgularised LIkelihood OptimisatioN) is a stand-alone
 computer program for Maximum A Posteriori refinement of (multiple) 3D
 reconstructions or 2D class averages in cryo-electron microscopy.
 .
 RELION provides a GUI, several command-line tools in parallel (MPI) and serial
 versions, optionally with CUDA/GPU support.
 .
 relion-cuda provides the serial and parallel (MPI) command-line tools with
 CUDA/GPU support.

Package: relion-gui-cuda
Architecture: amd64 i386
Depends: openmpi-gcc | openmpi-bin,
         relion-cuda,
         ${misc:Depends},
         ${shlibs:Depends},
Breaks: relion-bin,
        relion-bin+gui,
        relion-bin+mpi,
        relion-bin+mpi+gui,
Replaces: relion-bin,
          relion-bin+gui,
          relion-bin+mpi,
          relion-bin+mpi+gui,
Conflicts: relion-gui,
Description: parallel toolkit for 3D reconstructions in cryo-electron microscopy
 RELION (for REgularised LIkelihood OptimisatioN) is a stand-alone
 computer program for Maximum A Posteriori refinement of (multiple) 3D
 reconstructions or 2D class averages in cryo-electron microscopy.
 .
 RELION provides a GUI, several command-line tools in parallel (MPI) and serial
 versions, optionally with CUDA/GPU support.
 .
 relion-gui-cuda provides the graphical user interface with CUDA/GPU support.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

DEBVENDOR  := $(shell dpkg-vendor --query Vendor)

ifeq ($(DEBVENDOR), Qlustar)
    # Qlustar specific stuff
    include /usr/share/ql-deb-utils/Makefile
    MPICXX := mpicxx.openmpi-gcc
else
    include /usr/share/dpkg/default.mk

    NUMJOBS := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    MAKE_-J := $(addprefix -j, $(NUMJOBS))
    MPICXX := mpicxx.openmpi
endif

CONFIGURE_COMMON := cmake -DCMAKE_INSTALL_PREFIX=/usr \
  -DCMAKE_FIND_PACKAGE_NO_PACKAGE_REGISTRY=ON "-GUnix Makefiles" \
  -DCMAKE_VERBOSE_MAKEFILE=ON \
  -DCMAKE_SKIP_RPATH=TRUE \
  -DDoublePrec_GPU=ON

%:
	dh $@

override_dh_auto_configure:

override_dh_auto_build:
	mkdir $(CURDIR)/build
	cd $(CURDIR)/build; \
	$(CONFIGURE_COMMON) -DGUI=ON -DCUDA=ON $(CURDIR); \
	make $(MAKE_-J); DESTDIR=$(CURDIR)/debian/tmp/cli make install
	mkdir -p $(CURDIR)/debian/tmp/gui/usr/bin
	rm $(CURDIR)/debian/tmp/cli/usr/bin/*.csh # Useless ...
	for prog in relion relion_display relion_maingui relion_manualpick; do \
	  mv $(CURDIR)/debian/tmp/cli/usr/bin/$$prog \
	    $(CURDIR)/debian/tmp/gui/usr/bin; done

override_dh_prep:
	# We don't want debian/tmp to be removed again ...
	dh_prep -X debian/tmp

override_dh_auto_install:

override_dh_install-arch:
	dh_install -a

override_dh_clean:
	dh_clean
	-rm -rf build*

get-orig-source:
	uscan --download-current-version --force-download --rename

## relion-cuda 3.1.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -39,7 +39,6 @@
     # add the automatically determined parts of the RPATH
     # which point to directories outside the build tree to the install RPATH
     SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
-
 
     # the RPATH to be used when installing, but only if it's not a system directory
     LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
@@ -231,10 +230,9 @@
 message(STATUS "MPI_C_COMPILER : ${MPI_C_COMPILER}")
 message(STATUS "MPI_CXX_COMPILER : ${MPI_CXX_COMPILER}")
 
-set(SAVE_CMAKE_C_COMPILER ${CMAKE_C_COMPILER})
-set(SAVE_CMAKE_CXX_COMPILER ${CMAKE_CXX_COMPILER})
 SET(CMAKE_C_COMPILER ${MPI_C_COMPILER})
 SET(CMAKE_CXX_COMPILER ${MPI_CXX_COMPILER})
+
 set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
 set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
 set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
@@ -243,31 +241,36 @@
 # ----------------------------------  and build flags including MKL and TBB ---------
 
 message(STATUS "CMAKE_CXX_COMPILER_ID : ${CMAKE_CXX_COMPILER_ID}")
-if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
+
+if(MKLFFT)
+    if (NOT "$ENV{MKLROOT}" STREQUAL "")
+        include_directories("$ENV{MKLROOT}/include/fftw")
+        message(STATUS "MKL FFTW wrapper header files: $ENV{MKLROOT}/include/fftw")
+    else()
+        message("COMPILATION MAY FAIL since no MKL FFTW wrapper header files could be found. Please make sure the MKLROOT environmental variable is set.")
+    endif()
+    add_definitions(-DMKLFFT)
+endif(MKLFFT)
+
+if("${CMAKE_CXX_COMPILER_ID}" MATCHES "Intel" OR "${CMAKE_CXX_COMPILER}" MATCHES "icpx")
+# "Intel" is for classic Intel compiler and "IntelLLVM" is for oneAPI compiler which is supported from CMake 3.20
     if(MKLFFT)
-        SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fopenmp -mkl -limf ")
-    	add_definitions(-DMKLFFT)
+        if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
+            SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -qopenmp -mkl=parallel -limf ")
+        else()	# Intel oneAPI compiler
+            SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fiopenmp -mkl=parallel -limf ")
+        endif()
     endif(MKLFFT)
     if(ALTCPU)
         add_definitions(-DFAST_CENTERFFT)
     endif()
-    SET(CudaTexture OFF)
-    SET(CMAKE_C_COMPILER ${SAVE_CMAKE_C_COMPILER})
-    SET(CMAKE_CXX_COMPILER ${SAVE_CMAKE_CXX_COMPILER})
-    SET(MPI_C_COMPILER ${SAVE_CMAKE_C_COMPILER})
-    SET(MPI_CXX_COMPILER ${SAVE_CMAKE_CXX_COMPILER})
 else()
     if(MKLFFT)
         # For the time being, let's use the sequential version (as with FFTW)
-        SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -lmkl_intel_ilp64 -lmkl_core -lmkl_sequential ")
-        add_definitions(-DMKLFFT)
+        link_directories("$ENV{MKLROOT}/lib/intel64")
+        SET(FFTW_LIBRARIES mkl_intel_lp64 mkl_sequential mkl_core)
     endif(MKLFFT)
 endif()
-
-message(STATUS "CMAKE_C_COMPILER : ${CMAKE_C_COMPILER}")
-message(STATUS "CMAKE_CXX_COMPILER : ${CMAKE_CXX_COMPILER}")
-message(STATUS "MPI_C_COMPILER : ${MPI_C_COMPILER}")
-message(STATUS "MPI_CXX_COMPILER : ${MPI_CXX_COMPILER}")
 
 if(ALTCPU)
     add_definitions(-DALTCPU)
@@ -305,5 +308,3 @@
 	endif(NOT FLTK_FOUND)
 
     else(X11_FOUND)
-        message( STATUS "\n-- ------------------ YOU HAVE NO X11-LIBS ------------------")
-        message( STATUS "CCmake found no X11-libs on your system, which are required for the GUI.")

=== src/apps/CMakeLists.txt ===
--- 
+++ 
@@ -19,8 +19,14 @@
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/")
 include(GetGitRevisionDescription)
 get_git_head_revision(GIT_REFSPEC GIT_SHA1_FULL)
-string(SUBSTRING ${GIT_SHA1_FULL} 0 6 GIT_SHA1)
-message(STATUS "Git commit ID: ${GIT_SHA1_FULL}")
+set(RELION_VERSION_SUFFIX "")
+if (GIT_SHA1_FULL)
+   string(SUBSTRING ${GIT_SHA1_FULL} 0 6 GIT_SHA1_PREFIX)
+   if (NOT GIT_SHA1_PREFIX STREQUAL "GITDIR")
+      message(STATUS "Git commit ID: ${GIT_SHA1_FULL}")
+      set(RELION_VERSION_SUFFIX "-commit-${GIT_SHA1_PREFIX}")
+   endif()
+endif()
 configure_file("${CMAKE_SOURCE_DIR}/src/macros.cpp.in" "${CMAKE_BINARY_DIR}/macros.cpp" @ONLY)
 
 if (ALTCPU)
@@ -60,7 +66,7 @@
 file(GLOB REL_HP "${CMAKE_SOURCE_DIR}/src/Healpix_2.15a/*.cc")
 file(GLOB RELION_TARGETS "${CMAKE_SOURCE_DIR}/src/apps/*.cpp")
 
-set(GUI_TARGETS display maingui manualpick pipeliner)
+set(GUI_TARGETS maingui display manualpick)
 
 #--Remove apps using X11 if no GUI--
 if(NOT GUI)
@@ -71,7 +77,7 @@
 
 #--Remove apps for testing--
 #SET(RELION_TEST TRUE)
-set(TEST_TARGETS double_reconstruct_openmp cs_fit ctf_nyquist_test free_aberration_plot split_stack defocus_stats double_bfac_fit interpolation_test motion_diff paper_data_synth Zernike_test vis_delocalisation vis_Ewald_weight)
+set(TEST_TARGETS movie_reconstruct double_reconstruct_openmp cs_fit ctf_nyquist_test free_aberration_plot split_stack defocus_stats double_bfac_fit interpolation_test motion_diff paper_data_synth Zernike_test vis_delocalisation vis_Ewald_weight)
 if(NOT RELION_TEST)
 	foreach(TARGET ${TEST_TARGETS})
 		list(REMOVE_ITEM RELION_TARGETS "${CMAKE_SOURCE_DIR}/src/apps/${TARGET}.cpp")
@@ -194,13 +200,18 @@
 
 foreach (_target ${RELION_TARGETS})
 	GET_FILENAME_COMPONENT(_target "relion_${_target}" NAME_WE)  #specify target name WE=WithoutExtension
-	
-	add_executable(${_target} ${_target}.cpp )
+
+	if(${_target} STREQUAL "maingui") # We no longer want "relion_maingui"
+		set(_target "relion")
+		add_executable(${_target} maingui.cpp)
+	else()
+		add_executable(${_target} ${_target}.cpp )
+		set_target_properties(${_target} PROPERTIES PREFIX "relion_")
+	endif()
+
 	set(LIB relion_lib)
 	
  	add_dependencies(${_target} relion_lib)
-	
-	set_target_properties(${_target} PROPERTIES PREFIX "relion_")
 
 	if(NOT MKLFFT)
 		target_link_libraries(${_target} ${LIB} ${EXTRA_LIBS} ${MPI_LIBRARIES} ${CMAKE_DL_LIBS})
@@ -223,7 +234,7 @@
 	)
 	
 	list(FIND GUI_TARGETS ${_target} IS_GUI_TARGET)
-	if(NOT ${IS_GUI_TARGET} LESS 0)
+	if((NOT ${IS_GUI_TARGET} LESS 0) OR (${_target} STREQUAL "relion"))
 		add_dependencies(${_target} relion_gui_lib)
 		target_link_libraries(${_target} relion_gui_lib ${FLTK_LIBRARIES} ${X11})
 	endif()
@@ -236,14 +247,6 @@
 	
 	install (TARGETS ${_target} RUNTIME DESTINATION bin)
 endforeach()
-
-if(GUI)
-	ADD_CUSTOM_COMMAND(TARGET maingui
-	                   POST_BUILD
-                           COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_BINARY_DIR}/bin/relion_maingui ${PROJECT_BINARY_DIR}/bin/relion
-                           COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_BINARY_DIR}/bin/relion_qsub.csh ${PROJECT_BINARY_DIR}/bin/qsub.csh
-	)
-endif(GUI)
 
 FIND_PACKAGE( OpenMP REQUIRED)
 if(OPENMP_FOUND)

=== debian/changelog ===
relion-cuda (3.1.3-2) unstable; urgency=medium

  * Team upload.
  * Fix watch file
  * Rebuild for the libtiff5 -> libtiff6 transition
    Closes: #1029179

 -- Andreas Tille <tille@debian.org>  Thu, 19 Jan 2023 07:57:26 +0100

relion-cuda (3.1.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream version.
  * Build using cuda-gcc.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 29 Sep 2022 14:56:00 +0200

relion (3.1.3-2) unstable; urgency=medium

  [ Andreas Beckmann ]
  * Team upload.
  * Cherry-pick upstream fixes related to cub.  (Closes: #995224)
  * Simplify debian/rules.
  * Fix missing hardening flags.
  * Build for Architecture: any.
  * Standards-Version: 4.6.1.
  * Fix some typos found by Lintian.

  [ Andreas Tille ]
  * Enable uscan to create a sensible download name

 -- Andreas Beckmann <anbe@debian.org>  Thu, 29 Sep 2022 13:27:08 +0200

relion (3.1.3-1) unstable; urgency=medium

  * Fix watchfile to detect new versions on github
  * New upstream version
  * Standards-Version: 4.6.0 (routine-update)
  * Update renamed lintian tag names in lintian overrides.
  * Mark autopkgtest superficial

 -- Andreas Tille <tille@debian.org>  Tue, 19 Oct 2021 09:16:04 +0200

relion (3.1.0-4) unstable; urgency=medium

  * Drop useless get-orig-source target (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Trim trailing whitespace.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Build-Depends: fluid

 -- Andreas Tille <tille@debian.org>  Wed, 07 Oct 2020 16:03:12 +0200

relion (3.1.0-3) unstable; urgency=medium

  * relion-cuda and relion-gui-cuda are now built by src:relion-cuda/contrib.

 -- Roland Fehrenbacher <rfehren@debian.org>  Thu, 01 Oct 2020 10:37:37 +0200

relion (3.1.0-2) unstable; urgency=medium

  * New upstream version 3.1.0
  * Update to Standards-Version: 4.5.0
  * Rename available binary packages, since MPI support is now default.
    The MPI enabled binaries carry a suffix _mpi, serial versions are still
    available.
  * Dropped librelion* packages. No shared libraries are created by relion
    anymore.
  * Add versions with CUDA/GPU support (these are in the Debian contrib
    archive area). They are named relion-cuda and relion-gui-cuda.
  * Moved to dep14 layout to work directly with the upstream git repo (see
    README.source in the source archive).
  * Added a simple autopkgtest

 -- Roland Fehrenbacher <rfehren@debian.org>  Tue, 29 Sep 2020 19:01:31 +0000

relion (1.4+dfsg-4) unstable; urgency=medium

  * Team upload.
  * Add watch file (and delete README.source that explains why there is no
    watch file)
  * New upstream version
  * debhelper 11
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.1.4
  * Restrict architectures to amd64 and i386
    Closes: #897239

 -- Andreas Tille <tille@debian.org>  Thu, 14 Jun 2018 14:10:42 +0200

relion (1.4+dfsg-3) unstable; urgency=medium

  * Team upload
  * d/control: Enable all archs, Closes: #873865
  * d/control: Update standards to 4.1.1 (no changes)

 -- Gert Wollny <gewo@debian.org>  Thu, 07 Dec 2017 10:27:59 +0100

relion (1.4+dfsg-2) unstable; urgency=medium

  [ Gert Wollny ]
  * Team upload.
  * d/p/0005: Correct compilation with gcc-6, Closes: #811641
  * d/p/0006: Correctly copy only 4 byte, corresponding to the
    target array size
  * d/control: Update standards version to 3.9.8

  [ Andreas Tille ]
  * hardening=+bindnow

 -- Gert Wollny <gw.fossdev@gmail.com>  Wed, 29 Jun 2016 13:32:34 +0000

relion (1.4+dfsg-1) unstable; urgency=medium

  [ Roland Fehrenbacher ]
  * New upstream version 1.4
  * Bug fix: "file conflicts between librelion{+mpi}{+gui}-1.3-1{v5}
    packages", thanks to Ralf Treinen (Closes: #797825).

  [ Andreas Tille ]
  * Enable building architecture independant files separately
    Closes: #806103

 -- Roland Fehrenbacher <rf@q-leap.de>  Tue, 08 Dec 2015 19:04:50 +0100

relion (1.3+dfsg-3) unstable; urgency=medium

  [ Andreas Tille ]
  * Rename library packages for g++5 ABI transition.
    (Thanks for the patch to Iain Lane <iain@orangesquash.org.uk>)
    Closes: #791267

  [ Roland Fehrenbacher ]
  * Fix permissions of d/lib*.install files (needed for dh-exec)

 -- Roland Fehrenbacher <rf@q-leap.de>  Mon, 24 Aug 2015 16:08:36 +0000

relion (1.3+dfsg-2) unstable; urgency=medium

  * Drop build-dep on openmpi-gcc
    Closes: #766821

 -- Andreas Tille <tille@debian.org>  Sun, 26 Oct 2014 07:40:11 +0100

relion (1.3+dfsg-1) unstable; urgency=low

  * Initial upload (Closes: #766324)

 -- Roland Fehrenbacher <rf@q-leap.de>  Thu, 23 Oct 2014 11:52:48 +0000

=== debian/control ===
--- 
+++ 
@@ -9,16 +9,16 @@
                libfltk1.3-dev,
                libopenmpi-dev,
                libtiff-dev,
-               nvidia-cuda-toolkit,
+               nvidia-cuda-toolkit-gcc,
                fluid
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/med-team/relion
 Vcs-Git: https://salsa.debian.org/med-team/relion.git
 Homepage: https://www2.mrc-lmb.cam.ac.uk/relion/index.php/Main_Page
+Rules-Requires-Root: no
 
 Package: relion-cuda
-Section: contrib/science
-Architecture: amd64 i386
+Architecture: any
 Depends: openmpi-gcc | openmpi-bin,
          ${misc:Depends},
          ${shlibs:Depends},
@@ -43,9 +43,9 @@
  CUDA/GPU support.
 
 Package: relion-gui-cuda
-Architecture: amd64 i386
-Depends: openmpi-gcc | openmpi-bin,
-         relion-cuda,
+Architecture: any
+Depends:
+         relion-cuda (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends},
 Breaks: relion-bin,
@@ -57,7 +57,7 @@
           relion-bin+mpi,
           relion-bin+mpi+gui,
 Conflicts: relion-gui,
-Description: parallel toolkit for 3D reconstructions in cryo-electron microscopy
+Description: toolkit for 3D reconstructions in cryo-electron microscopy (gui apps)
  RELION (for REgularised LIkelihood OptimisatioN) is a stand-alone
  computer program for Maximum A Posteriori refinement of (multiple) 3D
  reconstructions or 2D class averages in cryo-electron microscopy.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

DEBVENDOR  := $(shell dpkg-vendor --query Vendor)

ifeq ($(DEBVENDOR), Qlustar)
    # Qlustar specific stuff
    include /usr/share/ql-deb-utils/Makefile
    MPICXX := mpicxx.openmpi-gcc
else
    include /usr/share/dpkg/default.mk

    NUMJOBS := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    MAKE_-J := $(addprefix -j, $(NUMJOBS))
    MPICXX := mpicxx.openmpi
endif

CFLAGS		+= $(CPPFLAGS)
CXXFLAGS	+= $(CPPFLAGS)

CONFIGURE_COMMON := cmake -DCMAKE_INSTALL_PREFIX=/usr \
  -DCMAKE_FIND_PACKAGE_NO_PACKAGE_REGISTRY=ON "-GUnix Makefiles" \
  -DCMAKE_VERBOSE_MAKEFILE=ON \
  -DCMAKE_SKIP_RPATH=TRUE \
  -DDoublePrec_GPU=ON

%:
	dh $@

override_dh_auto_configure:
	mkdir $(CURDIR)/build
	cd $(CURDIR)/build; \
	$(CONFIGURE_COMMON) -DCUDA_HOST_COMPILER=/usr/bin/cuda-gcc -DGUI=ON -DCUDA=ON $(CURDIR)

override_dh_auto_build:
	$(MAKE) $(MAKE_-J) -C build

override_dh_auto_install:
	$(MAKE) -C build install DESTDIR=$(CURDIR)/debian/tmp/cli
	mkdir -p $(CURDIR)/debian/tmp/gui/usr/bin
	rm $(CURDIR)/debian/tmp/cli/usr/bin/*.csh # Useless ...
	set -e; for prog in relion relion_display relion_manualpick; do \
	  mv $(CURDIR)/debian/tmp/cli/usr/bin/$$prog \
	    $(CURDIR)/debian/tmp/gui/usr/bin; done

override_dh_clean:
	dh_clean
	-rm -rf build

=== debian/tests/control ===
Test-Command: /usr/bin/relion_refine
Depends: relion-cuda
Restrictions: superficial
